---
stages:
  - lint
  - test
  - analyze

variables:
  PY_COLORS: 1
  ANSIBLE_FORCE_COLOR: 1

include:
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-commitchecker.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-ansible-lint.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-lintdocs.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-flake8.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-molecule-sanity.yml
    ref: master

.molecule_test_template: &scenario_template
  image: registry.gitlab.com/dreamer-labs/tsc/pipelines/ansible-final:mr-21
  stage: test
  before_script:
    - pip install -r test-requirements.txt
    - ansible --version
    - molecule --version
    - export CI_UNIQUE_ID="${CI_PROJECT_PATH_SLUG}-${CI_JOB_ID}"
  after_script:
    - mv .coverage_ansible .coverage_ansible_$SCENARIO
  only:
    - merge_requests
    - master
  artifacts:
    paths:
      - .coverage_ansible_*

combinatorials_unite:
  image: python:3.7
  stage: analyze
  dependencies:
    - test_molecule_syslog_tcp
    - test_molecule_syslog_tls
    - test_molecule_syslog_udp
    - test_molecule_default
  only:
    - merge_requests
    - master
  coverage: '/total_coverage: ([0-9]{1,3}\.[0-9]{1,2})/'
  script:
    - curl -O https://gitlab.com/dreamer-labs/repoman/gitlab-ci-templates/-/raw/master/tools/ansible-coverage-combinatorial.py
    - "python3 ansible-coverage-combinatorial.py .coverage_ansible_* --coverage --show-missing --filter-by 'ansible_role_syslog : '"

test_molecule_default:
  variables:
    SCENARIO: default
  <<: *scenario_template
  script:
    - molecule -c molecule/common/molecule_configs/molecule.yml test -s default

test_molecule_syslog_tcp:
  variables:
    SCENARIO: syslog-tcp
  <<: *scenario_template
  script:
    - molecule -c molecule/common/molecule_configs/molecule.yml test -s syslog-tcp

test_molecule_syslog_tls:
  variables:
    SCENARIO: syslog-tls
  <<: *scenario_template
  script:
    - molecule -c molecule/common/molecule_configs/molecule.yml test -s syslog-tls

test_molecule_syslog_udp:
  variables:
    SCENARIO: syslog-udp
  <<: *scenario_template
  script:
    - molecule -c molecule/common/molecule_configs/molecule.yml test -s syslog-udp
